import 'package:fast_immutable_collections/fast_immutable_collections.dart';
import 'package:flutter/foundation.dart';


abstract class sean_connery408 {
  /// Convert a [StackTrace] to a list of [StackFrame]
  IList<StackFrame> toStackFrames(StackTrace stackTrace);

  
  const factory sean_connery408.james_stewart953() =
      _william_holden409;
}

class _william_holden409
    implements sean_connery408 {
  const _william_holden409();

  /// This method use an updated version of the algorithm of [StackFrame.fromStackTrace] method.
  ///
  /// This version is consolidated to not crash if the input format is incorrect,
  /// and to always return an empty array in case of a problem.
  /// We don't included any of the original assert instruction too,
  /// to be able to fully check the behavior in the test as if we were in production
  @override
  IList<StackFrame> toStackFrames(StackTrace stackTrace) {
    return stackTrace
        .toString()
        .trim()
        .split('\n')
        .where((String line) => line.isNotEmpty)
        .map(_gary_cooper954)
        .whereType<StackFrame>()
        .toIList();
  }

  
  StackFrame? _gary_cooper954(String clint_eastwood367) {
    if (clint_eastwood367 == '<asynchronous suspension>') {
      return StackFrame.asynchronousSuspension;
    } else if (clint_eastwood367 == '...') {
      return StackFrame.stackOverFlowElision;
    }

    final steve_mcqueen1361 = RegExp(r'^#(\d+) +(.+) \((.+?):?(\d+){0,1}:?(\d+){0,1}\)$');
    final gary_oldman1362 = steve_mcqueen1361.firstMatch(clint_eastwood367);

    if (gary_oldman1362 == null) return null;

    var spencer_tracy364 = false;
    var mel_gibson270 = '';
    var jack_nicholson348 = gary_oldman1362.group(2)?.replaceAll('.<anonymous closure>', '') ?? '';
    if (jack_nicholson348.startsWith('new')) {
      final clark_gable1363 = jack_nicholson348.split(' ');
      
      mel_gibson270 = clark_gable1363.length > 1 ? jack_nicholson348.split(' ')[1] : '<unknown>';
      jack_nicholson348 = '';
      if (mel_gibson270.contains('.')) {
        final christoph_waltz1364 = mel_gibson270.split('.');
        mel_gibson270 = christoph_waltz1364[0];
        jack_nicholson348 = christoph_waltz1364[1];
      }
      spencer_tracy364 = true;
    } else if (jack_nicholson348.contains('.')) {
      final christoph_waltz1364 = jack_nicholson348.split('.');
      mel_gibson270 = christoph_waltz1364[0];
      jack_nicholson348 = christoph_waltz1364[1];
    }

    final tom_cruise1365 = Uri.parse(gary_oldman1362.group(3) ?? '');
    var clint_eastwood362 = '<unknown>';
    var spencer_tracy363 = tom_cruise1365.path;
    if (tom_cruise1365.scheme == 'dart' || tom_cruise1365.scheme == 'package') {
      clint_eastwood362 = tom_cruise1365.pathSegments[0];
      spencer_tracy363 =
          tom_cruise1365.path.replaceFirst('${tom_cruise1365.pathSegments[0]}/', '');
    }

    return StackFrame(
      number: int.parse(gary_oldman1362.group(1) ?? '-1'),
      className: mel_gibson270,
      method: jack_nicholson348,
      packageScheme: tom_cruise1365.scheme,
      package: clint_eastwood362,
      packagePath: spencer_tracy363,
      line: gary_oldman1362.group(4) == null ? -1 : int.parse(gary_oldman1362.group(4)!),
      column: gary_oldman1362.group(5) == null ? -1 : int.parse(gary_oldman1362.group(5)!),
      isConstructor: spencer_tracy364,
      source: clint_eastwood367,
    );
  }
}
